Magellan Linux

Contents of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log


Revision 2433 - (show annotations) (download)
Tue Jan 7 14:18:40 2014 UTC (10 years, 3 months ago) by niro
File size: 19074 byte(s)
-use pushd/popd instead of simple cd
1 #!/bin/bash
2 # $Id$
3 #
4 # Simple Installation Script
5 # merged from alxinstall-ng and mcore-installer
6 #
7 # Niels Rogalla <niro@magellan-linux.de>
8 #
9
10 # ignore the environment
11 LC_ALL=C
12 # include dir
13 INSTALLER_LIBDIR="%LIBDIR%"
14
15 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16 # -> now in images.conf
17 CURRENTLINE=0
18
19 die()
20 {
21 echo "Error: $@"
22 exit 1
23 }
24
25 # load common includes
26 for inc in %SYSCONFDIR%/installer.conf \
27 ${INSTALLER_LIBDIR}/functions/common.sh \
28 ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29 ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30 ${INSTALLER_LIBDIR}/functions/bootloader.sh \
31 ${INSTALLER_LIBDIR}/functions/initrd-tools.sh \
32 ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
33 do
34 if [ -e ${inc} ]
35 then
36 source "${inc}"
37 else
38 die "'${inc}' not found"
39 fi
40 done
41
42 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
43 # -> now in images.conf
44 CDIMAGENAME=""
45 TOTALLINES=""
46 CURRENTLINE=0
47 if [ -e /mnt/cdrom/system/images.conf ]
48 then
49 source /mnt/cdrom/system/images.conf
50 # check if all required variables are set
51 [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
52 [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
53 else
54 die "/mnt/cdrom/system/images.conf not found"
55 fi
56
57 ### System/Config Version
58 VERSION="%VERSIONTAG%"
59 TITLE="${DEFAULT_TITLE} - ${VERSION}"
60
61 # some sane defaults
62 CDROOT="${DEFAULT_CDROOT}"
63 INSTALLROOT="${DEFAULT_INSTALLROOT}"
64 KERNELPKG="${DEFAULT_KERNELPKG}"
65 KERNELOPTS="${DEFAULT_KERNELOPTS}"
66 GRUBLEGACYOPTS=""
67 GRUB2OPTS=""
68 FDISKPARTIONBELOW256MB=0
69 SPECIALDEVICE=""
70 FORMFACTOR="${DEFAULT_FORMFACTOR}"
71 FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
72
73 #################################################
74 # DIALOG BOXEN #
75 #################################################
76
77 trap_exit()
78 {
79 is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
80 is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
81 is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
82 is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
83 is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
84
85 echo $"Installation aborted."
86 exit 1
87 }
88
89 dialog_die()
90 {
91 ERROR="$1"
92 RETVAL="$?"
93 dialog_install_failure
94 exit 1
95 }
96
97 dialog_warning()
98 {
99 local retval
100
101 yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
102 retval=$?
103 if [[ ${retval} -eq 1 ]]
104 then
105 clear
106 echo $"The process was aborted."
107 exit 1
108 fi
109 }
110
111 dialog_setup_hdd_info()
112 {
113 local SHDD="${HDD//\/dev\/}"
114
115 messagebox -h $"[ Harddrive partitioning ]" \
116 $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."
117 }
118
119 dialog_setup_hdd_info_auto()
120 {
121 local SHDD="${HDD//\/dev\/}"
122
123 messagebox -h $"[ Harddrive partitioning ]" \
124 $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
125 }
126
127 dialog_setup_system_menu()
128 {
129 local mode
130 local retval
131
132 mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \
133 $"1:Automatic setup (recommended)" \
134 ":" \
135 $":\Z1Expert modes:\Zn" \
136 $"2:Common IDE-disk (manual setup)")
137 retval=$?
138 [[ ${retval} -eq 1 ]] && return 1
139 if [[ ${retval} -eq 0 ]]
140 then
141 case "${mode}" in
142 "1") run_install_auto ;;
143 "2") run_install_normal ;;
144 "") dialog_setup_system_menu;;
145 esac
146 fi
147 }
148
149 dialog_hardware_detection()
150 {
151 local message
152
153 run_hardware_detection_disks
154
155 message+=$"Harddrives:\n"
156
157 if [[ ! -z ${ALL_DISKS} ]]
158 then
159 for i in ${ALL_DISKS}
160 do
161 message+="\Z3${i}\Zn "
162 done
163 message+="\n"
164 fi
165
166 if [[ ! -z ${ALL_CDROMS} ]]
167 then
168 message+="\n"
169 message+=$"Optical disk drives:\n"
170 for i in ${ALL_CDROMS}
171 do
172 message+="\Z3${i}\Zn"
173 done
174 message+="\n"
175 fi
176
177 # other devices
178 run_hardware_detection
179 case "${SPECIALDEVICE}" in
180 zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
181 rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
182 maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
183 *) message+=$"\n \\ZnCommon device detected.\Zn" ;;
184 esac
185 if [[ ${FORMFACTOR} = laptop ]]
186 then
187 message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
188 fi
189
190 messagebox -y 15 -h $"Detected hardware:" "${message}"
191 }
192
193 dialog_setup_hdd_partitions_manual()
194 {
195 local i
196 local retval
197
198 if [[ -z ${ALL_DISKS} ]]
199 then
200 dialog_no_harddrive_found
201 exit 1
202 else
203 HDD=$(dialog_select_target_harddrive)
204 retval=$?
205 [[ ${retval} -eq 1 ]] && return 1
206 if [[ ${retval} -eq 0 ]]
207 then
208 dialog_setup_hdd_info
209 setup_hdd_partitions_manual
210 fi
211 fi
212 }
213
214 dialog_setup_hdd_partitions_auto()
215 {
216 local i
217 local retval
218
219 if [[ -z ${ALL_DISKS} ]]
220 then
221 dialog_no_harddrive_found
222 exit 1
223 else
224 HDD=$(dialog_select_target_harddrive)
225 retval=$?
226 [[ ${retval} -eq 1 ]] && return 1
227 if [[ ${retval} -eq 0 ]]
228 then
229 dialog_setup_hdd_info_auto
230 dialog_setup_hdd_create_partitions
231 setup_hdd_partitions_auto
232 fi
233 fi
234 }
235
236 install_meter()
237 {
238 while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
239 do
240 CURRENTLINE=$(grep -c . /tmp/install.log)
241 PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))
242 echo ${PERCENT}
243 sleep 1
244 done
245 rm -f /tmp/install.log
246 return 0
247 }
248
249 dialog_main()
250 {
251 local method=0
252 local retval
253
254 while [[ ${method} -le 2 ]]
255 do
256 method=$(menubox $"Configuration:" \
257 $"1:Install system" \
258 $"2:Show detected harddrives" \
259 $"3:Exit and reboot" \
260 $"4:Exit and drop into a shell")
261 retval=$?
262 [[ ${retval} -eq 1 ]] && exit 1
263 if [[ ${retval} -eq 0 ]]
264 then
265 case ${method} in
266 "1") dialog_setup_system_menu ;;
267 "2") dialog_hardware_detection ;;
268 "3") install_do_reboot ;;
269 "4") /bin/bash --login -i ;;
270 esac
271 fi
272 done
273 }
274
275 #################################################
276 # Install Komandos #
277 #################################################
278 run_hardware_detection()
279 {
280 local hwinfo
281
282 hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
283
284 ## check for special devices/clients:
285 ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
286 #local removable=0
287 #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
288 #then
289 #for i in /sys/block/[hs]d*/removable
290 #do
291 #if [[ $(< ${i}) = 1 ]]
292 #then
293 #removable=1
294 #fi
295 #done
296 ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
297
298 ## only add this for grub legacy, grub2 detect these settings on its own
299 #export GRUBLEGACYOPTS="rootdelay=8"
300 ## there are to zotac types in the wild, nvidia based gfx and intel
301 #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
302 #then
303 #export SPECIALDEVICE="zotac_nvidia"
304 #else
305 #export SPECIALDEVICE="zotac_intel"
306 #fi
307 #fi
308
309 # check for special devices/clients:
310 # if a rangee and disk ist smaller then 256mb move partion one block further ahead
311 if [[ ! -z $(echo "${hwinfo}" | grep -i CLE266) ]]
312 then
313 # for a rangee always define partion startblock +1
314 export FDISKPARTIONBELOW256MB="1"
315 export SPECIALDEVICE="rangee"
316 export GRUBLEGACYOPTS=""
317 fi
318
319 # check for special devices/clients:
320 # check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer
321 if [[ ! -z $(echo "${hwinfo}" | grep -i i810) ]] || [[ ! -z $(echo "${hwinfo}" | grep -i i815) ]]
322 then
323 export SPECIALDEVICE="maxdata"
324 export GRUBLEGACYOPTS=""
325 fi
326
327 # check for special devices/clients:
328 # check for laptops and activate cpufreq scaling
329 if [[ $(echo "${hwinfo}" | grep 'Formfactor:' | sed 's:.*Formfactor\:\ \"\(.*\)\":\1:') = laptop ]]
330 then
331 export FORMFACTOR="laptop"
332 export KERNELOPTS="${KERNELOPTS} cpufreq.governor=ondemand"
333 fi
334 }
335
336 run_hardware_detection_disks()
337 {
338 local bootdev
339
340 # all disks but exclude ramdisks
341 export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
342 # remove the boot device from ALL_DISKS if it was an usbstick
343 if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
344 then
345 bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
346 export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
347 fi
348 export ALL_CDROMS="$(get_hwinfo cdrom)"
349 }
350
351 hdd_size_below_256mb()
352 {
353 local hdd="$1"
354 local size
355 local retval
356 [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
357
358 size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
359 if [[ ${size} -le 257000000 ]]
360 then
361 retval="0"
362 else
363 retval="1"
364 fi
365
366 return "${retval}"
367 }
368
369 setup_hdd_partitions_auto()
370 {
371 ROOTHDD="${HDD}1"
372
373 # run this only if FDISKPARTITIONBELOW256MB is not already 1
374 if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
375 then
376 if hdd_size_below_256mb ${HDD}
377 then
378 FDISKPARTIONBELOW256MB=1
379 else
380 FDISKPARTIONBELOW256MB=0
381 fi
382 fi
383
384 ## delete disk
385 dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
386
387 if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
388 then
389 ## setup one bootable partition
390 #1. n= new disk
391 #2. p= primary disk
392 #3. 1= first partition
393 #4. 2= default sector start // small disk needs more space for grub2 mbr sector
394 #5. ''= defaul sector end
395 #6. a= bootable flag
396 #7. 1= boot flag for partition 1
397 #8. w= write/quit
398 fdisk ${HDD} &> /dev/null << EOF
399 n
400 p
401 1
402 2
403
404 a
405 1
406 w
407 EOF
408 else
409 ## setup one bootable partition
410 #1. n= new disk
411 #2. p= primary disk
412 #3. 1= first partition
413 #4. ''= default sector start
414 #5. ''= defaul sector end
415 #6. a= bootable flag
416 #7. 1= boot flag for partition 1
417 #8. w= write/quit
418 fdisk ${HDD} &> /dev/null << EOF
419 n
420 p
421 1
422
423
424 a
425 1
426 w
427 EOF
428 fi
429 }
430
431 setup_hdd_partitions_manual()
432 {
433 ROOTHDD="${HDD}1"
434
435 ## hdds partitionieren manual
436 cfdisk ${HDD} || dialog_die
437 }
438
439 setup_hdd_format()
440 {
441 mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
442 }
443
444 install_mount_rootfs()
445 {
446 mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
447 install -d ${INSTALLROOT}/boot || dialog_die
448 cd ${INSTALLROOT} || dialog_die
449 }
450
451 install_system_image()
452 {
453 pushd ${INSTALLROOT} > /dev/null
454 tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
455 popd > /dev/null
456 }
457
458 install_bootsector_chroot()
459 {
460 local my_roothdd
461 local grubconf=${INSTALLROOT}/boot/grub/grub.conf
462 local grub2conf=/boot/grub/grub.cfg
463
464 # check for grub2
465 if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
466 then
467 # needed by grub-mkconfig on the first run
468 if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
469 then
470 install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
471 fi
472
473 # set kernelopts
474 if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
475 then
476 sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
477 else
478 echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" > ${INSTALLROOT}/etc/conf.d/grub || dialog_die
479 fi
480 echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
481 echo "LC_ALL=C grub-mkconfig -o ${grub2conf} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
482 echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
483 echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
484
485 # grub-legacy
486 else
487 ### grubconf schreiben
488 source ${INSTALLROOT}/boot/kernelversion
489
490 #for alx only
491 if [ -e ${INSTALLROOT}/etc/alx_version ]
492 then
493 OLD_ALXVER="${ALXVER}"
494 source ${INSTALLROOT}/etc/alx_version
495 KRNVER="ALX-${ALXVER}"
496 ALXVER="${OLD_ALXVER}"
497 fi
498
499 [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"
500 [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"
501 [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"
502
503 # uuid support
504 if is_uuid_supported
505 then
506 my_roothdd="UUID=$(get_uuid ${ROOTHDD})"
507 else
508 my_roothdd="${ROOTHDD}"
509 fi
510
511 : > ${grubconf} || dialog_die
512 echo "default 0" >> ${grubconf} || dialog_die
513 echo "timeout 3" >> ${grubconf} || dialog_die
514 # using current root password
515 echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)" >> ${grubconf} || dialog_die
516
517 echo >> ${grubconf} || dialog_die
518 echo "# normal boot" >> ${grubconf} || dialog_die
519 echo "title ${KRNVER}" >> ${grubconf} || dialog_die
520 echo "root (hd0,0)" >> ${grubconf} || dialog_die
521 echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die
522 if is_initrd_supported
523 then
524 echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
525 fi
526
527 echo >> ${grubconf} || dialog_die
528 echo "# admin boot" >> ${grubconf} || dialog_die
529 echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die
530 echo "lock" >> ${grubconf} || dialog_die
531 echo "root (hd0,0)" >> ${grubconf} || dialog_die
532 echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die
533 if is_initrd_supported
534 then
535 echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
536 fi
537
538 echo >> ${grubconf} || dialog_die
539 echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die
540 echo "lock" >> ${grubconf} || dialog_die
541 echo "root (hd0,0)" >> ${grubconf} || dialog_die
542 echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die
543 if is_initrd_supported
544 then
545 echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
546 fi
547
548 # bootsector schreiben chrooted schreiben (lfs/magellan)
549 cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
550 /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
551 root (hd0,0)
552 setup (hd0)
553 quit
554 EOF
555 exit 0
556 CHROOTEOF
557 fi
558
559 ## enter chroot
560 mount -t proc proc ${INSTALLROOT}/proc
561 mount -t sysfs sysfs ${INSTALLROOT}/sys
562 mount -o bind /dev ${INSTALLROOT}/dev
563 chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
564 umount ${INSTALLROOT}/proc
565 umount ${INSTALLROOT}/sys
566 umount ${INSTALLROOT}/dev
567 rm ${INSTALLROOT}/root/.installrc
568 }
569
570 is_initrd_supported()
571 {
572 # only generate initrds if the cmd exists
573 [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0
574 return 1
575 }
576
577 install_initrd_chroot()
578 {
579 # only generate initrds if the cmd exists
580 is_initrd_supported || return 0
581
582 DISKMODS="sd_mod"
583 OLDPATAMODS="amd74xx piix sis5513 via82cxxx"
584 PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"
585 SATAMODS="sata_via sata_sis sata_nv"
586 DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"
587 OTHERMODS=""
588 case ${SPECIALDEVICE} in
589 zotac_intel) FBMODS=""; DRMMODS="i915" ;;
590 zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;
591 rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards
592 # not working with kms enabled drivers -> segfaults
593 #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer
594 maxdata) FBMODS="" ;;
595 *) FBMODS="uvesafb" ;;
596 esac
597
598 if [[ ${FORMFACTOR} = laptop ]]
599 then
600 OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"
601 fi
602
603 # install an appropriate uvesafb.conf
604 install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
605 echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
606
607 # install an appropriate viafb.conf
608 echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
609
610 # install an appropriate i810fb.conf
611 echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60" > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
612
613 cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
614 echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
615 mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
616 exit 0
617 CHROOTEOF
618
619 ## enters chroot
620 mount -t proc proc ${INSTALLROOT}/proc
621 mount -t sysfs sysfs ${INSTALLROOT}/sys
622 mount -o bind /dev ${INSTALLROOT}/dev
623 chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
624 umount ${INSTALLROOT}/proc
625 umount ${INSTALLROOT}/sys
626 umount ${INSTALLROOT}/dev
627 rm ${INSTALLROOT}/root/.installrc
628 }
629
630 is_uuid_supported()
631 {
632 if [[ -x $(type -P busybox.mkinitrd) ]]
633 then
634 # only detect uuids if supported
635 if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
636 then
637 return 0
638 fi
639 fi
640
641 return 1
642 }
643
644 get_uuid()
645 {
646 local UUID
647 local SEC_TYPE
648 local TYPE
649
650 local dev="$1"
651 [[ -z ${dev} ]] && dialog_die "no dev given"
652
653 # check if given device is already an UUID
654 if [[ ${dev/UUID=/}x != ${dev}x ]]
655 then
656 eval "${dev}"
657 else
658 eval $(busybox.mkinitrd blkid ${dev} | grep "${dev}:" | sed 's/.*:\ //')
659 fi
660 echo "${UUID}"
661 }
662
663 install_system_settings()
664 {
665 # schreibe fstab
666 if is_uuid_supported
667 then
668 echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
669 else
670 echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
671 fi
672 # not needed busybox loads all with swapon -a, even if not mentioned in fstab
673 #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
674 echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
675 echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
676
677 # install network config skeleton
678 install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die
679
680 # intel framebufer quirk
681 if [[ -e /proc/fb ]]
682 then
683 if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
684 then
685 fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
686 if [[ ${fbdev} != 0 ]]
687 then
688 sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
689 fi
690 fi
691 fi
692 }
693
694 install_umount_rootfs()
695 {
696 umount ${INSTALLROOT}/boot || dialog_die
697 umount ${INSTALLROOT} || dialog_die
698 }
699
700 install_do_reboot()
701 {
702 reboot
703 }
704
705 #################################################
706 # Install Ablauf Scripte #
707 #################################################
708
709 run_install_normal()
710 {
711 dialog_hardware_detection
712
713 dialog_setup_hdd_partitions_manual
714 dialog_setup_hdd_format
715 setup_hdd_format > /dev/null
716 install_mount_rootfs
717 (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
718
719 dialog_install_settings
720 sleep 1
721 install_system_settings
722 dialog_install_initrd
723 install_initrd_chroot
724
725 dialog_install_bootsector
726 install_bootsector_chroot
727
728 install_umount_rootfs
729 dialog_install_successful
730 }
731
732 run_install_auto()
733 {
734 dialog_hardware_detection
735
736 dialog_setup_hdd_partitions_auto
737 dialog_setup_hdd_format
738 setup_hdd_format > /dev/null
739 install_mount_rootfs
740 (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
741
742 dialog_install_settings
743 sleep 1
744 install_system_settings
745 dialog_install_initrd
746 install_initrd_chroot
747
748 dialog_install_bootsector
749 install_bootsector_chroot
750
751 install_umount_rootfs
752 dialog_install_successful
753 }
754
755 # set some proper traps
756 trap "trap_exit" SIGINT SIGQUIT
757
758 dialog_main
759
760 exit 0